0000                    ;
0000                    ; MZ-1M01 IPL-ROM TEST PROGRAM
0000                    ;
0000                    ;  RAM DISK for S-OS"SWORD" in 8bit mode
0000                    ;
0000
1D19                    PATADR	EQU	1D19H
1FE2                    MPRINT	EQU	1FE2H
20FF                    ETRK	EQU	20FFH
2B00                    DOSMOD	EQU	2B00H
2B07                    DREAD	EQU	2B07H
2B17                    DWRTE	EQU	2B17H
0000
0000                    	ORG	8000H
8000
8000                    ;
8000                    ; Init PIO
8000                    ;
8000    CD E2 1F        START:	CALL	MPRINT
8003    52 61 6D 64     	DB	"Ramdisk driver replacement",0DH
8007    69 73 6B 20
800B    64 72 69 76
800F    65 72 20 72
8013    65 70 6C 61
8017    63 65 6D 65
801B    6E 74 0D
801E    20 20 66 6F     	DB	"  for using 16-BIT BOARD KIT",0DH,0DH,00H
8022    72 20 75 73
8026    69 6E 67 20
802A    31 36 2D 42
802E    49 54 20 42
8032    4F 41 52 44
8036    20 4B 49 54
803A    0D 0D 00
803D
803D    F3              	DI
803E    3E 29           	LD	A,VECT >> 8
8040    ED 47           	LD	I,A
8042    ED 5E           	IM	2
8044    21 9A 80        	LD	HL,IOTBL
8047    06 08           	LD	B,8
8049    7E              INIL:	LD	A,(HL)
804A    23              	INC	HL
804B    4E              	LD	C,(HL)
804C    23              	INC	HL
804D    ED 79           	OUT	(C),A
804F    10 F8           	DJNZ	INIL
8051                    ;
8051                    ; Replace RAMDISK procedure
8051                    ;
8051    21 AA 80        	LD	HL,PATDT
8054    11 54 29        	LD	DE,RDSUB
8057    01 AC 00        	LD	BC,CHKPA0 - RDSUB + 1
805A    ED B0           	LDIR
805C
805C    21 56 81        	LD	HL,PATDT + (CHKPA0 - RDSUB + 1)
805F    11 DB 2C        	LD	DE,GETPA
8062    01 21 00        	LD	BC,IFLAGB - GETPA + 1
8065    ED B0           	LDIR
8067
8067    21 54 29        	LD	HL,RDSUB	; Patch for new driver
806A    22 01 2B        	LD	(DOSMOD + 1),HL
806D    21 5D 29        	LD	HL,WTSUB
8070    22 04 2B        	LD	(DOSMOD + 4),HL
8073
8073    21 19 1D        	LD	HL,PATADR	; 1D19 LD HL,($DTAFR)
8076    3E C9           	LD	A,0C9H		;    -> RET
8078    77              	LD	(HL),A
8079
8079    3E 1F           	LD	A,1Fh		; Cluster size
807B    32 FF 20        	LD	(ETRK),A
807E                    ;
807E                    ; Enter 88-IPL debug mode
807E                    ;
807E    FB              	EI
807F    0E 01           	LD	C,1
8081    CD F2 29        	CALL	PUTPA
8084
8084    CD E2 1F        	CALL	MPRINT
8087    73 65 74 75     	DB	"setup completed.",0DH,00H
808B    70 20 63 6F
808F    6D 70 6C 65
8093    74 65 64 2E
8097    0D 00
8099    C9              	RET
809A
809A                    ;
809A                    ; Z80A PIO initialize words
809A                    ;
809A    66 D5           IOTBL:	DW	0D5H:VECT & 0FFH
809C    8F D5           	DW	0D58FH
809E    87 D5           	DW	0D587H
80A0    68 D7           	DW	0D7H:(VECT & 0FFH) + 2
80A2    CF D7           	DW	0D7CFH
80A4    7F D7           	DW	0D77FH
80A6    97 D7           	DW	0D797H
80A8    FF D7           	DW	0D7FFH
80AA
80AA                    PATDT:
80AA
80AA                    ;
80AA                    ; RAM DISK read/write routine
80AA                    ;
80AA                    ; HL ... memory address for read/write
80AA                    ; DE ... begin record number
80AA                    ; A  ... number of records
80AA                    ;
80AA
80AA                    	ORG	2954H
2954
2954    08              RDSUB:	EX	AF,AF'
2955    FE 04           	CP	4
2957    28 18           	JR	Z,RDRAM
2959    08              	EX	AF,AF'
295A    C3 07 2B        	JP	DREAD
295D
295D    08              WTSUB:	EX	AF,AF'
295E    FE 04           	CP	4
2960    28 1A           	JR	Z,WTRAM
2962    08              	EX	AF,AF'
2963    C3 17 2B        	JP	DWRTE
2966
2966                    ;
2966                    ; Interrupt vector
2966                    ;
2966    E8 2C           VECT:	DW	INTPA
2968    F1 2C           	DW	INTPB
296A                    ;
296A                    ; work for parameter
296A                    ;
296A    01              PARTBL:	DB	01H		; command
296B    00 00           	DW	0000H		; offset
296D    00 00           	DW	0000H		; segment
296F    00 00           	DW	0000H		; size
2971
2971    DD E5           RDRAM:	PUSH	IX
2973    C5              	PUSH	BC
2974    DD 21 A3 29     	LD	IX,RDRAM2
2978    0E 01           	LD	C,01H		; read memory command
297A    18 09           	JR	RDRAM0
297C
297C    DD E5           WTRAM:	PUSH	IX
297E    C5              	PUSH	BC
297F    DD 21 BB 29     	LD	IX,WTRAM1
2983    0E 02           	LD	C,02H		; write memory command
2985
2985    08              RDRAM0:	EX	AF,AF'
2986    D5              	PUSH	DE
2987    E5              	PUSH	HL
2988
2988                    ;
2988                    ; check record number
2988                    ;
2988    26 00           	LD	H,0
298A    6F              	LD	L,A
298B    47              	LD	B,A
298C    19              	ADD	HL,DE
298D    7C              	LD	A,H
298E    B7              	OR	A
298F    28 09           	JR	Z,RDRAM1
2991    E6 FE           	AND	0FEH
2993    20 1D           	JR	NZ,BDREC
2995    7D              	LD	A,L
2996    FE F0           	CP	0F0H
2998    30 18           	JR	NC,BDREC
299A    CD C8 29        RDRAM1:	CALL	SETPAR		; command
299D    E1              	POP	HL
299E    E5              	PUSH	HL
299F    06 00           	LD	B,0
29A1    DD E9           	JP	(IX)
29A3
29A3    DB D4           RDRAM2:	IN	A,(0D4H)	; DUMMY
29A5    CD DB 2C        L_RDR:	CALL	GETPA
29A8    77              	LD	(HL),A
29A9    23              	INC	HL
29AA    10 F9           	DJNZ	L_RDR
29AC    1D              	DEC	E
29AD    20 F6           	JR	NZ,L_RDR
29AF    B7              	OR	A
29B0    18 03           	JR	RAMRT
29B2    3E 05           BDREC:	LD	A,5		; bad record error
29B4    37              	SCF
29B5    E1              RAMRT:	POP	HL
29B6    D1              	POP	DE
29B7    C1              	POP	BC
29B8    DD E1           	POP	IX
29BA    C9              	RET
29BB
29BB    4E              WTRAM1:	LD	C,(HL)
29BC    23              	INC	HL
29BD    CD F2 29        	CALL	PUTPA
29C0    10 F9           	DJNZ	WTRAM1
29C2    1D              	DEC	E
29C3    20 F6           	JR	NZ,WTRAM1
29C5    B7              	OR	A
29C6    18 ED           	JR	RAMRT
29C8
29C8                    ;
29C8                    ; Set parameter for xfer
29C8                    ;
29C8    21 6A 29        SETPAR:	LD	HL,PARTBL
29CB    E5              	PUSH	HL
29CC    71              	LD	(HL),C
29CD    23              	INC	HL
29CE    23              	INC	HL
29CF    23              	INC	HL
29D0    CB 23           	SLA	E
29D2    CB 12           	RL	D
29D4    CB 23           	SLA	E
29D6    CB 12           	RL	D
29D8    CB 23           	SLA	E
29DA    CB 12           	RL	D
29DC    CB 23           	SLA	E
29DE    CB 12           	RL	D
29E0    73              	LD	(HL),E		; segment low
29E1    23              	INC	HL
29E2    72              	LD	(HL),D		; segment high
29E3    23              	INC	HL
29E4    23              	INC	HL
29E5    70              	LD	(HL),B		; size high
29E6
29E6    06 07           	LD	B,7
29E8    E1              	POP	HL
29E9    4E              SETL:	LD	C,(HL)
29EA    23              	INC	HL
29EB    CD F2 29        	CALL	PUTPA
29EE    10 F9           	DJNZ	SETL
29F0    59              	LD	E,C
29F1    C9              	RET
29F2
29F2                    ;
29F2                    ; put 1 byte to 8088
29F2                    ;
29F2    AF              PUTPA:	XOR	A
29F3    32 F0 2C        	LD	(IFLAGA),A
29F6    79              	LD	A,C
29F7    D3 D4           	OUT	(0D4H),A
29F9    3A F0 2C        CHKPA:	LD	A,(IFLAGA)
29FC    B7              	OR	A
29FD    28 FA           	JR	Z,CHKPA
29FF    C9              CHKPA0:	RET
2A00
2A00                    	ORG	2CDBH
2CDB                    ;
2CDB                    ; get 1 byte from 8088
2CDB                    ;
2CDB    3A FB 2C        GETPA:	LD	A,(IFLAGB)
2CDE    B7              	OR	A
2CDF    28 FA           	JR	Z,GETPA
2CE1    AF              	XOR	A
2CE2    32 FB 2C        	LD	(IFLAGB),A
2CE5    DB D4           	IN	A,(0D4H)
2CE7    C9              	RET
2CE8
2CE8                    ;
2CE8                    ; Interrupt hundler for PIO-Aport
2CE8                    ;
2CE8    F5              INTPA:	PUSH	AF
2CE9    3E 01           	LD	A,1
2CEB    32 F0 2C        	LD	(IFLAGA),A
2CEE    18 07           	JR	INTEX
2CF0    00              IFLAGA:	DB	0
2CF1
2CF1                    ;
2CF1                    ; Interrupt hundler for PIO-Bport
2CF1                    ;
2CF1    F5              INTPB:	PUSH	AF
2CF2    3E 01           	LD	A,1
2CF4    32 FB 2C        	LD	(IFLAGB),A
2CF7    F1              INTEX:	POP	AF
2CF8    FB              	EI
2CF9    ED 4D           	RETI
2CFB    00              IFLAGB:	DB	0
2CFC
